#include <assert.h>
#include <stdio.h>
#include <string.h>

#define TASKNAME "cube"

const int MaxN = 10, MaxL = 1 << MaxN;

int a [MaxL];
int m, n;

int recur (int cur)
{
 int i, res, next;
 res = 0;
 for (i = 1; i < m; i <<= 1)
  if (!(cur & i))
  {
   next = recur (cur | i);
   if (res < next) res = next;
  }
 return res + a[cur];
}

int main (void)
{
 int i;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  m = 1 << n;
  for (i = 0; i < m; i++)
   scanf (" %d", &a[i]);
  printf ("%d\n", recur (0));
 }
 return (0);
}
