#include <assert.h>
#include <math.h>
#include <stdio.h>

#define TASKNAME "fraction"
typedef long double real;

const int MaxN = 1000;
const real eps = 1E-5;

int main (void)
{
 int n, x, t;
 real p, p0;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  p = sqrt (n);
  x = int (p);
  t = x << 1;
  printf ("[%d", x);
  if (fabs (p - x) > eps)
  {
   p = 1.0 / (p - x);
   x = int (p);
   printf (";(%d", x);
   p0 = p;
   p = 1.0 / (p - x);
   while (fabs (p - p0) > eps)
   {
//    printf ("{%.20lf}\n", double (p));
    x = int (p);
    if (x >= t)
    {
     x = t;
     printf (",%d", x);
     break;
    }
    printf (",%d", x);
    p = 1.0 / (p - x);
   }
   printf (")");
  }
  printf ("]\n");
 }
 return (0);
}
