// Problem: Gears
// Author: Ivan Kazmenko
// Simulation solution
#include <assert.h>
#include <stdio.h>

#define TASKNAME "gears"
typedef long int int32;

const int MinN = 2, MaxN = 4;
const int32 MaxC = 50L * 49L * 48L * 47L;

int main (void)
{
 int a [MaxN], b [MaxN];
 int i, n;
 int32 res;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  for (i = 0; i < n; i++)
   assert (scanf (" %d", &a[i]) == 1 && a[i] >= 5 && a[i] <= 50);
  for (i = 0; i < n; i++)
   assert (scanf (" %d", &b[i]) == 1 && a[i] >= 0 && b[i] < a[i]);
  for (res = 0; res < MaxC; res++)
  {
   for (i = 0; i < n; i++)
    if (b[i]) break;
   if (i == n) break;
   for (i = 0; i < n; i++)
   {
    b[i]--;
    if (b[i] < 0) b[i] += a[i];
   }
  }
  assert (res < MaxC); // The solution is guaranteed to exist!
  printf ("%ld\n", res);
 }
 return 0;
}
