program CCube;

{$APPTYPE CONSOLE}
{$O+,Q-,R-}

uses
  SysUtils;

Function Can(A:Longint; B:Longint):Boolean;
Begin
A := A - 1; B := B - 1;
Can := False;
If (A Xor B <> 0)Then
  If (A And (A Xor B) = 0) Then Can := True;
End;

Var A, B, N:Longint;
    P:Array[1..1024] Of Longint;
    MP:Array[1..1024] Of Longint;
    Pow:Array[0..10] Of Longint = (1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024);
begin
Assign (input, 'cube.in');
Reset (input);
Readln (input, N);
For A := 1 To Pow[N] Do
  Readln (input, P[A]);
Close (input);

FillChar (MP, SizeOf(MP), 255);
MP[1] := P[1];

For A := 1 To Pow[N] Do
  For B := A + 1 To Pow[N] Do
    If Can(A, B) Then
      If MP[B] < MP[A] + P[B] Then MP[B] := MP[A] + P[B];

Assign (output, 'cube.out');
Writeln (output, MP[Pow[N]]);
Close (output);
end.
