#include <assert.h>
#include <math.h>
#include <stdio.h>

#define TASKNAME "fraction"

const int MaxN = 1000, MaxL = 125;

int a [MaxL], b [MaxL], c [MaxL];

int main (void)
{
 int i, j, n, x;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  x = int (floor (sqrt (n)));
  i = 0, a[i] = b[i] = x, c[i] = n - x * x, i++;
  if (c[i - 1])
  {
   a[i] = (x + b[i - 1]) / c[i - 1];
   b[i] = a[i] * c[i - 1] - b[i - 1];
   c[i] = (n - b[i] * b[i]) / c[i - 1];
   for (i++; a[i - 1] < (x << 1); i++)
   {
    assert (i < MaxL);
    a[i] = (x + b[i - 1]) / c[i - 1];
    b[i] = a[i] * c[i - 1] - b[i - 1];
    c[i] = c[i - 2] + ((a[i] * b[i - 1]) << 1) - (a[i] * a[i]) * c[i - 1];
   }
  }
  printf ("[%d", a[0]);
  if (i > 1)
  {
   printf (";(");
   for (j = 1; j < i; j++) printf ("%d%c", a[j], (j < i - 1) ? ',' : ')');
  }
  printf ("]\n");
 }
 return (0);
}
