// Problem: Gears
// Author: Ivan Kazmenko
// Fast solution - loops unrolled
#include <assert.h>
#include <stdio.h>

#define TASKNAME "gears"
typedef long int int32;

const int MaxN = 4;
const int32 MaxC = 50L * 49L * 48L * 47L;

int main (void)
{
 int a1, a2, a3, a4, b1, b2, b3, b4;
 int n;
 int32 res;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  scanf (" %d", &a1);
  scanf (" %d", &a2);
  if (n > 2) scanf (" %d", &a3); else a3 = 1;
  if (n > 3) scanf (" %d", &a4); else a4 = 1;
  scanf (" %d", &b1);
  scanf (" %d", &b2);
  if (n > 2) scanf (" %d", &b3); else b3 = 0;
  if (n > 3) scanf (" %d", &b4); else b4 = 0;
  for (res = 0; res < MaxC; res++)
  {
   if (b1 == 0 && b2 == 0 && b3 == 0 && b4 == 0)
    break;
   b1--; if (b1 < 0) b1 += a1;
   b2--; if (b2 < 0) b2 += a2;
   b3--; if (b3 < 0) b3 += a3;
   b4--; if (b4 < 0) b4 += a4;
  }
  assert (res < MaxC); // The solution is guaranteed to exist!
  printf ("%ld\n", res);
 }
 return 0;
}
